<?php
class blognetworkingactions extends wv43v_action {
	public function blognetworking_write_networkWPfilter($data) {
		$data ['last_updated'] = '';
		if (isset ( $data ['url'] )) {
			$links = $this->get_links ( $data ['url'] );
			$blogs = $this->get_blogs ( $links );
			$this->application ()->data ( 'posts' )->posts = $this->select_order ( $blogs, $data );
			$data ['last_updated'] = time ();
		
		}
		return $data;
	}	
	public function update() {
		$values = $this->application ()->data ()->network;
		if ((time () - $values ['last_updated']) / 60 >= $values ['between']) {
			$this->application ()->data ()->network = $values;
		}
	}
	private function get_blogs($links) {
		$blog = array ();
		foreach ( $links as $link ) {
			if ($link ['xml_url'] != '') {
				@$feed = fetch_rss ( $link ['xml_url'] );
				if ($feed) {
					$newblog = array ();
					if(isset($feed->channel['title']))
					{
						$newblog ['title'] = $feed->channel ['title'];
						$newblog ['link'] = '#';
						if(isset($feed->channel['link']))
						{
							$newblog ['link'] = $feed->channel ['link'];
						}
						$newblog ['description'] = '';
						if(isset($feed->channel['description']))
						{
							$newblog ['description'] = $feed->channel ['description'];
						}
						$newblog ['items'] = array ();
						foreach ( $feed->items as $item ) {
							$newitem = array ();
							$newitem ['title'] = $item ['title'];
							$newitem ['link'] = $item ['link'];
							$newitem ['pubdate'] = $item ['pubdate'];
							$newitem ['author'] = $item ['dc'] ['creator'];
							$newblog ['items'] [] = $newitem;
						}
						$feed = null;
						$blog [] = $newblog;
					}
				}
			}
		}
		return $blog;
	}
	private function get_links($blogroll) {
		$f = new av43v_opml ( $blogroll );
		$OPML = $f->get ();
		$fixed = array ();
		foreach ( $OPML as $okey => $o ) {
			foreach ( ( array ) $o as $v ) {
				if (isset ( $v ['tag'] ) && $v ['tag'] == 'BODY') {
					foreach ( ( array ) $v as $v2 ) {
						if (isset ( $v2 ['tag'] ) && $v2 ['tag'] == 'OUTLINE') {
							$cat = $v2 ['attributes'] ['TITLE'];
							foreach ( ( array ) $v2 as $v3 ) {
								if (isset ( $v3 ['tag'] ) && $v3 ['tag'] == 'OUTLINE' && $v3 ['attributes'] ['TYPE'] == 'link') {
									$fixed_new = array ();
									$fixed_new ['title'] = $v3 ['attributes'] ['TEXT'];
									$fixed_new ['html_url'] = $v3 ['attributes'] ['HTMLURL'];
									$fixed_new ['xml_url'] = $v3 ['attributes'] ['XMLURL'];
									$fixed_new ['categories'] = $cat;
									if (array_key_exists ( $fixed_new ['title'], $fixed )) {
										$fixed [$fixed_new ['title']] ['categories'] .= ',' . $fixed_new ['categories'];
									} else {
										$fixed [$fixed_new ['title']] = $fixed_new;
									}
								}
							}
						}
					}
				}
			}
		}
		return $fixed;
	}
	public function select_order($blogs, $settings) {
		$posts = array ();
		foreach ( $blogs as $blog ) {
			$blog_det = $blog;
			unset ( $blog_det ['items'] );
			$cnt = 0;
			foreach ( $blog ['items'] as $item ) {
				$post = $item;
				$post ['blog'] = $blog_det;
				$posts [] = $post;
				$cnt ++;
				if ($cnt == $settings ['site_max']) {
					break;
				}
			}
		}
		usort ( $posts, array ($this, 'single_sort' ) );
		$newposts = array ();
		$cnt = 0;
		foreach ( $posts as $post ) {
			$cnt ++;
			$newposts [] = $post;
			if ($cnt == $settings ['net_max']) {
				break;
			}
		}
		$posts = $newposts;
		$newposts = null;
		return $posts;
	}
	public function single_sort($a, $b) {
		if (strtotime ( $a ['pubdate'] ) == strtotime ( $b ['pubdate'] )) {
			return 0;
		}
		return (strtotime ( $a ['pubdate'] ) > strtotime ( $b ['pubdate'] )) ? - 1 : 1;
	}
	public function initWPaction() {
		add_action ( 'showNetwork', array ($this, 'showNetwork' ) );
		blognetwidget::$application = $this->application ();
		register_widget ( 'blognetwidget' );
	}
	public function showNetwork($title = '') {
		if ($title == '') {
			$title = "Recent Community Posts";
		}
		$this->update ();
		$this->view->data = $this->application ()->data ( 'posts' )->posts;
		$this->view->title = $title;
		$this->view->_e ( $this->render_script ( 'front/widget.phtml' ) );
	}
	public function blognetworkingWPmenuMeta($return) {
		$return ['title'] = $this->application ()->name;
		$return ['menu'] = 'Settings';
		return $return;
	}
	public function settingsActionMeta($return) {
		$return ['link_name'] = $return ['title'];
		$return ['priority'] = - 1;
		$return ['classes'] [] = 'v43v_icon16x16';
		$return ['classes'] [] = 'v43v_icon16x16_settings';
		return $return;
	}
	public function settingsAction() {
		$this->view->data=$this->application ()->data ()->post ('network');
		$this->view->title = $this->help('settings')->render('Settings');
		$this->view->column_count=4;
		$search_replace=$this->data()->post('search_replace');
		$this->view->rows[] = $this->render_script('blognetworking/row1.phtml');
		$this->view->rows[] = $this->render_script('blognetworking/row2.phtml');
		$this->view->rows[] = $this->render_script('blognetworking/row3.phtml');
		$this->view->rows[] = $this->render_script('blognetworking/row4.phtml');
		$this->view->rows[] = $this->render_script('blognetworking/row5.phtml');
		$this->view->apply="Update Settings &amp; Network";
		return $this->render_table();
	}
}